
class Enemy < ControllableObject
  def initialize(template)
    super(template[:material])
    @picture = template[:picture]
    @skill = template[:skill][:class].new(self, template[:skill])
    @hp = template[:hp]
  end

  def update
    super
    dx = $app.player.x - x
    dy = $app.player.y - y
    projected = vec2(dx, dy) + $app.player.speed * MAT_ENEMY[:leash_speed] / vec2(dx, dy).length / 2
    @skill.update
    @skill.apply(dx, dy, :down) if vec2(dx, dy).length < 1000
    self.target = projected
  end

  def side
    SIDE_ENEMY
  end

  def draw
    RES::All.draw_frame(@picture, x, y, OBJSIZE / SPRITESIZE, OBJSIZE / SPRITESIZE)
  end

  def take_hit(bullet)
    @hp -= bullet.stats[:damage]
    @dead = @hp < 0
  end
end
