
class SlingerShootSkill < ShootSkill
  def initialize(*args)
    super
    @add_scatter = 0
    @ammo = @stats[:ammo]
    @reloading = false
  end

  def progress
    if @reloading
      1.0 - 1.0 * @delay / @stats[:reload]
    else
      1.0 * @ammo / @stats[:ammo]
    end
  end

  def update
    super
    if @delay == 0 && @reloading
      @reloading = false
      @ammo = @stats[:ammo]
    end
  end

  def apply(dx, dy, btn_state)
    return unless btn_state == :clicked
    return if @delay > 0
    return if @reloading
    super
    if @delay > 0
      @ammo -= 1
      if @ammo <= 0
        @delay = @stats[:reload]
        @reloading = true
      end
    end
  end
end

SLINGER_SHOT = {
  class: SlingerShootSkill,
  picture: TILE_SHOT,
  maxrange: 200,
  speed: 2000,
  spread: 0.05,
  count: 1,
  delay: 10,
  damage: 7,
  force: 15.0,
  ammo: 6,
  reload: 3 * 60,
}

SLINGER =
  {
    material: MAT_PLAYER,
    picture: 6 * 8 + 0,

    left_skill: SLINGER_SHOT,
    right_skill: SLINGER_SHOT,
  }
