MAT_ENEMY =
  {
    mass: 2.0,
    inertia: 1.0,
    elast: 0.1,
    friction: 0.1,
    leash_speed: 400.0,
    leash_force: 4000.0,
  }

ENEMY_MELEE = {
  picture: 7 * 8 + 1,
  hp: 10,

  skill: {
    class: ShootSkill,
    picture: TILE_SLASH,
    maxrange: 10,
    speed: 200,
    spread: 0.6,
    count: 1,
    delay: 50,
    damage: 1,
    force: 10.0,
  },
  material: MAT_ENEMY,
}

ENEMY_ARCHER = {
  picture: 7 * 8 + 2,
  hp: 5,

  skill: {
    class: ShootSkill,
    picture: TILE_STONES,
    maxrange: 500,
    speed: 400,
    spread: 0.2,
    count: 1,
    delay: 40,
    damage: 2,
  },
  material: {
    mass: 2.0,
    inertia: 1.0,
    elast: 0.1,
    friction: 0.1,
    leash_speed: 100.0,
    leash_force: 4000.0,
  },
}

class SummonSkill < Skill
  def initialize(*args)
    super
    @delay = 0
  end

  def apply(dx, dy, btn_state)
    return if @delay > 0
    @delay = stats[:delay]
    stats[:count].times do
      x = owner.x + rand - 0.5
      y = owner.y + rand - 0.5
      enemy = Enemy.new(ENEMY_MELEE)
      enemy.warp(x, y)
      $app.objects << enemy
    end
  end

  def progress
    1.0 - 1.0 * @delay / @stats[:delay]
  end

  def update
    @delay -= 1 if @delay > 0
  end
end

ENEMY_BOSS = {
  picture: 7 * 8 + 0,
  hp: 100,

  skill: {
    class: SummonSkill,
    delay: 10 * 60,
    count: 5,

  },
  material: MAT_ENEMY,
}
