require_relative "../bullet"
require_relative "../graph_consts"
require_relative "../lib/nonoengine"

class Skill
  attr_accessor :owner
  attr_accessor :stats

  def initialize(owner, stats)
    @stats = stats
    @owner = owner
  end

  def apply(dx, dy, btn_state)
  end

  def update
  end

  def progress
    1.0
  end
end

class ShootSkill < Skill
  def initialize(*args)
    super
    @delay = 0
  end

  def progress
    1.0 - 1.0 * @delay / @stats[:delay]
  end

  def update
    @delay -= 1 if @delay > 0 && (!@stats[:secondary] || @owner.left_skill.progress >= 0.99)
  end

  def apply(dx, dy, btn_state)
    return if @delay > 0
    @delay = @stats[:delay]
    spread = @stats[:spread]
    @stats[:count].times do
      angle = Math.atan2(dy, dx)
      angle += rand * spread - spread / 2.0
      spd = vec2(Math.cos(angle), Math.sin(angle)).normalize * @stats[:speed] * (1 + rand / 10) #+ @owner.speed
      $app.objects << Bullet.new(@owner.x, @owner.y, spd.x, spd.y, @owner.side, @stats)
    end
  end
end

N_CIRCLE = 32

def show_progress(x, y, r, value)
  xp = x
  yp = y
  (value * (N_CIRCLE + 1)).to_i.times do |i|
    a = -Math::PI / 2 + 2 * Math::PI / N_CIRCLE * i
    xn = x + Math.cos(a) * r
    yn = y + Math.sin(a) * r
    triangle2(xp, yp, xn, yn, x, y, 0x00000040)
    xp = xn
    yp = yn
  end
end

# require_relative "./test"
require_relative "./monster"
#require_relative "./warrior"
require_relative "./barbarian"
require_relative "./gunslinger"

ALL_CLASSES = [SLINGER, BARBARIAN]
